%% Script for determining optical middle of laser scanner camera.
%  Use file profile_water_20180223.0.dat (sawtooth profile under water,
%  measured at different heights of the camera)

for i=1:size(bedprofile{1},1)
    for j=1:9
        ind = find(bedprofile{1}(i,4:157)>(2410+(j-1)*60) & bedprofile{1}(i,4:157)<(2445+(j-1)*60));
        if isempty(ind) | isnan(ind)
            peaks2(i,j) = NaN; peaksInd2(i,j) = NaN;
        else
            [peaks2(i,j),peaksInd2(i,j)] = min(bedprofile{1}(i,ind+154)); peaksInd2(i,j) = bedprofile{1}(i,ind(peaksInd2(i,j)));
        end
    end
end

figure;
hold on;
for i=1:size(peaks2,1)
    plot(peaksInd2(i,:),peaks2(i,:),'-x');
end

%%
% MANUALLY REMOVE OUTLIERS BEFORE CONTINUING
%%

for i=1:size(peaks2,1)
    X = peaksInd2(i,:)'; Y = peaks2(i,:)';
    X(isnan(Y)) = []; Y(isnan(Y)) = [];
    if length(X)<3
        fit_abc(i,:) = NaN(1,3);
        minimum(i) = NaN;
    else
        fit_abc(i,:) = coeffvalues(fit(X,Y,'poly2'));
        minimum(i) = -fit_abc(i,2)/2/fit_abc(i,1);
    end
end

%%
zmin = 150;
zmax = 400;
zmin_plot = 150;

minimum_select = [];
if zmin==zmin_plot
    figure;
    hold on;
end
for i=1:length(minimum)
    minimum_z(i) = fit_abc(i,1)*minimum(i)^2+fit_abc(i,2)*minimum(i)+fit_abc(i,3);
if zmin==zmin_plot
    plot(peaksInd2(i,:),peaks2(i,:),'.-'); plot(minimum(i),minimum_z(i),'xk');
end
    if minimum_z(i)>=zmin & minimum_z(i)<=zmax
        minimum_select = [minimum_select minimum(i)];
    end
end

minimum_mean = mean(minimum_select)
if zmin==zmin_plot
    plot([minimum_mean minimum_mean],[zmin zmax],'-k');
end

%% same as previous section, but with a plot of minimum_mean vs. zmin
figure; hold on;

for zmin = 150:10:350
    zmax = 400;

    minimum_select = [];
    for i=1:length(minimum)
        minimum_z(i) = fit_abc(i,1)*minimum(i)^2+fit_abc(i,2)*minimum(i)+fit_abc(i,3);
        if minimum_z(i)>=zmin & minimum_z(i)<=zmax
            minimum_select = [minimum_select minimum(i)];
        end
    end

    minimum_mean = mean(minimum_select)

    plot(zmin,minimum_mean,'.k');
end
